<?php

$this->helper('license')->require();

// Register routes
$this->bindClass('Autopilot\\Controller\\Autopilot', '/autopilot');

// events

$this->on('app.permissions.collect', function ($permissions) {

    $permissions['Autopilot'] = [
        'autopilot/available' => 'Autopilot availability',
    ];
});

$this->on('app.layout.init', function () {

    $this->helper('theme')->vars('autopilot', $this->module('autopilot')->apiKey() ? true : false);

    if (!$this->module('autopilot')->apiKey()) {
        return;
    }

    $this->on('app.layout.assets', function (array &$assets) {

        if (!$this->module('autopilot')->apiKey()) {
            return;
        }

        $assets[] = ['src' => 'autopilot:assets/js/autopilot.js', 'type' => 'module'];
    });

    $this->start('app.layout.header');
?>
    <div>
        <button type="button" id="btnAutopilotAssistent" class="kiss-input-blank kiss-cursor-pointer" title="Autopilot Assistant">
            <kiss-svg src="<?=$this->baseUrl('autopilot:icon.svg')?>" width="30" height="30"></kiss-svg>
        </button>
        <script>
            btnAutopilotAssistent.addEventListener('click', function() {

                VueView.ui.modal('autopilot:assets/dialogs/chat.js', {}, {}, {
                    size: 'large',
                    escape: true
                });
            });
        </script>
    </div>
<?php
    $this->end('app.layout.header');
});
