<?php

$this->helper('license')->require();

// Register routes
$this->bindClass('Detektivo\\Controller\\Idx', '/detektivo/idx');
$this->bindClass('Detektivo\\Controller\\Detektivo', '/detektivo');

// events

$this->on('app.layout.init', function() {

    if (!$this->helper('acl')->isAllowed('detektivo/manage')) {
        return;
    }

    $this->helper('menus')->addLink('modules', [
        'label'  => 'Detektivo',
        'icon'   => 'detektivo:icon.svg',
        'route'  => '/detektivo',
        'active' => false,
        'group'  => 'Addons',
        'prio'   => 1
    ]);
});

$this->on('app.permissions.collect', function($permissions) {

    $permissions['Detektivo'] = [
        'detektivo/manage' => 'Manage indexes',
    ];
});

$this->on('app.search', function($search, $findings) {

    if (!$this->helper('acl')->isAllowed('detektivo/manage')) {
        return;
    }

    $indexes = $this->module('detektivo')->indexes();

    foreach ($indexes as $name => $index) {

        if (stripos($name, $search) !== false || stripos($index['label'], $search) !== false) {

            $findings[] = [
                'title' => $index['label'] ? $index['label'] : $name,
                'route' => $this->routeUrl("/detektivo/idx/{$name}"),
                'group' => 'Detektivo',
                'icon' => 'detektivo:assets/icons/index.svg'
            ];
        }
    }
});
