(function(global, $, $$) {

    const baseUrl = "<?=trim($this->module('system')->spaceUrl('/'), '/')?>";
    const storefrontAssetsBaseUrl = "<?=trim($this->pathToUrl('pages:assets/storefront', true), '/')?>";

    let uId = 0;

    const addTrigger = () => {

        let link = document.createElement('link');

        Object.assign(link, {
            rel: 'stylesheet',
            type: 'text/css',
            href: `${storefrontAssetsBaseUrl}/storefront.css`,
        });

        document.head.appendChild(link);

        setTimeout(() => {

            document.body.insertAdjacentHTML('afterend', '<div class="pages-storefront"><div class="pages-storefront-trigger"></div></div>');

            $('.pages-storefront-trigger').addEventListener('click', () => {
                location.href = `${baseUrl}/pages/storefront/frame?src=${encodeURI(location.href)}`;
            });

        }, 300);
    };

    let Lib = {

        isInIframe: false,

        init() {

            this.isInIframe = (window.location !== window.parent.location) && window.parent.location.href.indexOf(baseUrl) !== -1;

            if (!this.isInIframe) {
                return addTrigger();
            }

            window.addEventListener('beforeunload', () => {
                this.send('storefront:unload', {});
            });

            this.update();
        },

        update() {

            const storefront = window.STORE_FRONT || {};
            const modules = storefront.modules || {};

            $$('[data-storefront]').forEach((r) => {

                let data = r.getAttribute('data-storefront');

                try {
                    data = JSON.parse(data);

                    if (!data.module || !data.context || !data.data) {
                        return;
                    }

                    if (!modules[data.module]) {
                        modules[data.module] = {};
                    }

                    if (!modules[data.module][data.context]) {
                        modules[data.module][data.context] = [];
                    }

                    modules[data.module][data.context].push(data.data);

                    if (!r.getAttribute('data-storefront-id')) {
                        r.setAttribute('data-storefront-id', `spot-${++uId}`);
                    }

                    data.spotId = r.getAttribute('data-storefront-id');

                } catch (e) {
                    return;
                }
            });

            storefront.modules = modules;

            this.send('storefront:load', {
                src: location.href,
                title: document.head.querySelector('title').innerText,
                locale: document.documentElement.lang || 'default',
                storefront
            });
        },

        send(event, data) {
            window.parent.postMessage({event, data}, '*');
        }
    }

    window.addEventListener('message', (e) => {

        if (!e.data.event) return;

        let event = e.data.event;
        let data = e.data.data || {};

        switch (event) {
            case 'storefront:highlight':

                let ele = undefined;

                if (data.spotId) {
                    ele = $(`[data-storefront-id="${data.spotId}"]`);
                }

                console.log(ele)
                break;
        }

    }, false);

    Lib.init();

    global.storefront = Lib;

})(window, (s) => document.querySelector(s), (s) => document.querySelectorAll(s));
